using GTA;
using GTA.Native;
using GTA.Math;
using System;
using System.Windows.Forms;
using System.Collections.Generic;

public class BlipsCreator : Script
{
    bool _blipReloaded = false;
    List<Blip> _modBlips;

    public BlipsCreator()
    {
        _modBlips = new List<Blip>();
        GenerateBlips();
        Tick += BlipsCreator_Tick;
    }

    private void BlipsCreator_Tick(object sender,EventArgs e)
    {
        if(!_blipReloaded)
        {
            foreach(Blip bp in _modBlips)
            {
                if(!bp.Exists()) // In case it's deleted by another mod if that mod resets the all active blips
                {
                    GenerateBlips();
                    _blipReloaded = true;
                    break;
                }
            }
        }
    }

    private void GenerateBlips()
    {
        _modBlips.Clear();

        Blip Zancudo = World.CreateBlip(new Vector3(-2317f, 3396f, 30f)); //(-2317=x, 3396=y 30=z of Fort Zancudo Blip
        Function.Call(Hash.SET_BLIP_SPRITE, Zancudo, 598); //598=Kanjali Sprite
        Function.Call(Hash.SET_BLIP_COLOUR, Zancudo, 66); //66=yellow
        Function.Call(Hash._0xF9113A30DE5C6670, "STRING");                  //--|
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Fort Zancudo");     //  |--Name of the blip
        Function.Call(Hash._0xBC38B49BCB83BC9B, Zancudo);                   //..|
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Zancudo, true);// No blip on the corner of minnimap
        // New Addition
        _modBlips.Add(Zancudo);
 
    }
}