using GTA;
using GTA.Native;
using GTA.Math;
using System;
using System.Windows.Forms;
using System.Collections.Generic;

public class BlipsCreator : Script
{
    bool _blipReloaded = false;
    List<Blip> _modBlips;

    public BlipsCreator()
    {
        _modBlips = new List<Blip>();
        GenerateBlips();
        Tick += BlipsCreator_Tick;
    }

    private void BlipsCreator_Tick(object sender,EventArgs e)
    {
        if(!_blipReloaded)
        {
            foreach(Blip bp in _modBlips)
            {
                if(!bp.Exists()) // In case it's deleted by another mod if that mod resets the all active blips
                {
                    GenerateBlips();
                    _blipReloaded = true;
                    break;
                }
            }
        }
    }

    private void GenerateBlips()
    {
        _modBlips.Clear();

        Blip batteria = World.CreateBlip(new Vector3(-2451f, 2979f, 33f));
        Function.Call(Hash.SET_BLIP_SPRITE, batteria, 603);
        Function.Call(Hash.SET_BLIP_COLOUR, batteria, 1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, batteria, true);
        // New Addition
        _modBlips.Add(batteria);

        Blip Avenger = World.CreateBlip(new Vector3(-1845f, -3148f, 33f));
        Function.Call(Hash.SET_BLIP_SPRITE, Avenger, 589);
        Function.Call(Hash.SET_BLIP_COLOUR, Avenger, 1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Avenger, true);
        // New Addition
        _modBlips.Add(Avenger);

        Blip Kanjali = World.CreateBlip(new Vector3(-2192f, 3298f, 33f));
        Function.Call(Hash.SET_BLIP_SPRITE, Kanjali, 598);
        Function.Call(Hash.SET_BLIP_COLOUR, Kanjali, 66);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Kanjali");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Kanjali);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Kanjali, true);
        // New Addition
        _modBlips.Add(Kanjali);

        Blip mig = World.CreateBlip(new Vector3(1706f, 3252f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, mig, 16);
        Function.Call(Hash.SET_BLIP_COLOUR, mig, 66);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "MIG");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, mig);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, mig, true);
        // New Addition
        _modBlips.Add(mig);

        Blip Deluxo = World.CreateBlip(new Vector3(3578f, 3658f, 38f));
        Function.Call(Hash.SET_BLIP_SPRITE, Deluxo, 596);
        Function.Call(Hash.SET_BLIP_COLOUR, Deluxo, 1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Deluxo, true);
        // New Addition
        _modBlips.Add(Deluxo);

        Blip APC = World.CreateBlip(new Vector3(-1888, 2950, 38f));
        Function.Call(Hash.SET_BLIP_SPRITE, APC, 558);
        Function.Call(Hash.SET_BLIP_COLOUR, APC, 1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, APC, true);
        // New Addition
        _modBlips.Add(APC);

        Blip Ruiner = World.CreateBlip(new Vector3(1358f, -2095f, 38f));
        Function.Call(Hash.SET_BLIP_SPRITE, Ruiner, 530);
        Function.Call(Hash.SET_BLIP_COLOUR, Ruiner, 1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Ruiner, true);
        // New Addition
        _modBlips.Add(Ruiner);

        Blip Apache = World.CreateBlip(new Vector3(-1051f, -3489f, 38f));
        Function.Call(Hash.SET_BLIP_SPRITE, Apache, 576);
        Function.Call(Hash.SET_BLIP_COLOUR, Apache, 1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Apache, true);
        // New Addition
        _modBlips.Add(Apache);


        Blip Maze = World.CreateBlip(new Vector3(-164f, -2009f, 22f));
        Function.Call(Hash.SET_BLIP_SPRITE, Maze, 102);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Maze Bank Arena");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Maze);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Maze, true);
        // New Addition
        _modBlips.Add(Maze);


        Blip Sottomarino = World.CreateBlip(new Vector3(-1291f, 6855f, -175f));
        Function.Call(Hash.SET_BLIP_SPRITE, Sottomarino, 308);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Sottomarino");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Sottomarino);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Sottomarino, true);
        // New Addition
        _modBlips.Add(Sottomarino);

        Blip valkyrie = World.CreateBlip(new Vector3(503f, -3375f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, valkyrie, 576);
        Function.Call(Hash.SET_BLIP_COLOUR, valkyrie, 1);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Valkyrie");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, valkyrie);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, valkyrie, true);
        // New Addition
        _modBlips.Add(valkyrie);

        Blip Yatch1 = World.CreateBlip(new Vector3(-2061f, -1024f, 14f));
        Function.Call(Hash.SET_BLIP_SPRITE, Yatch1, 455);
        Function.Call(Hash.SET_BLIP_COLOUR, Yatch1, 3);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Yatcht");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Yatch1);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Yatch1, true);
        // New Addition
        _modBlips.Add(Yatch1);

        Blip Yatch2 = World.CreateBlip(new Vector3(-1407f, 6748f, 14f));
        Function.Call(Hash.SET_BLIP_SPRITE, Yatch2, 455);
        Function.Call(Hash.SET_BLIP_COLOUR, Yatch2, 3);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Yatcht");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Yatch2);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Yatch2, true);
        // New Addtion
        _modBlips.Add(Yatch2);

        Blip Base = World.CreateBlip(new Vector3(-361f, 4827f, 143f));
        Function.Call(Hash.SET_BLIP_SPRITE, Base, 548);
        Function.Call(Hash.SET_BLIP_COLOUR, Base, 2);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Base Missilistica");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Base);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Base, true);
        // New Addition
        _modBlips.Add(Base);

        Blip IAA = World.CreateBlip(new Vector3(2053f, 2947f, 47f));
        Function.Call(Hash.SET_BLIP_SPRITE, IAA, 564);
        Function.Call(Hash.SET_BLIP_COLOUR, IAA, 5);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Base IAA");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, IAA);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, IAA, true);
        // New Addition
        _modBlips.Add(IAA);

        Blip Ufficio = World.CreateBlip(new Vector3(-80f, -837f, 40f));
        Function.Call(Hash.SET_BLIP_SPRITE, Ufficio, 475);
        Function.Call(Hash.SET_BLIP_COLOUR, Ufficio, 1);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Ufficio");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Ufficio);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Ufficio, true);
        // New Addition
        _modBlips.Add(Ufficio);

        Blip Server = World.CreateBlip(new Vector3(2480f, -405f, 90f));
        Function.Call(Hash.SET_BLIP_SPRITE, Server, 459);
        Function.Call(Hash.SET_BLIP_COLOUR, Server, 2);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Server Farm");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Server);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Server, true);
        // New Addition
        _modBlips.Add(Server);

        Blip Lab = World.CreateBlip(new Vector3(3421f, 3757f, 22f));
        Function.Call(Hash.SET_BLIP_SPRITE, Lab, 588);
        //67
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Laboratori Humane");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Lab);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Lab, true);
        // New Addition
        _modBlips.Add(Lab);

        Blip Zancudo = World.CreateBlip(new Vector3(-2317f, 3396f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Zancudo, 600);
        Function.Call(Hash.SET_BLIP_COLOUR, Zancudo, 66);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Fort Zancudo");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Zancudo);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Zancudo, true);
        // New Addition
        _modBlips.Add(Zancudo);

        Blip Life = World.CreateBlip(new Vector3(-1079f, -262f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Life, 521);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "LifeInvader");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Life);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Life, true);
        // New Addition
        _modBlips.Add(Life);

        Blip Set = World.CreateBlip(new Vector3(-1215f, -582f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Set, 135);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Set Cinematografico");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Set);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Set, true);
        // New Addition
        _modBlips.Add(Set);

        Blip FIB = World.CreateBlip(new Vector3(66f, -735f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, FIB, 487);
        Function.Call(Hash.SET_BLIP_COLOUR, FIB, 3);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "FIB");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, FIB);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, FIB, true);
        // New Addition
        _modBlips.Add(FIB);

        Blip Playboy = World.CreateBlip(new Vector3(-1469f, 65f, 52f));
        Function.Call(Hash.SET_BLIP_SPRITE, Playboy, 279);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Playboy");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Playboy);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Playboy, true);
        // New Addition
        _modBlips.Add(Playboy);

        Blip Prigione = World.CreateBlip(new Vector3(1853f, 2605f, 45f));
        Function.Call(Hash.SET_BLIP_SPRITE, Prigione, 189);
        Function.Call(Hash.SET_BLIP_COLOUR, Prigione, 42);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Prigione");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Prigione, 42);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Prigione, true);
        // New Addition
        _modBlips.Add(Prigione);

        Blip AircraftCarrier = World.CreateBlip(new Vector3(3083.465f, -4659.136f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, AircraftCarrier, 16);
        Function.Call(Hash.SET_BLIP_COLOUR, AircraftCarrier, 66);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Portaerei");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, AircraftCarrier);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, AircraftCarrier, true);
        // New Addition
        _modBlips.Add(AircraftCarrier);

        Blip Teatro2 = World.CreateBlip(new Vector3(650f, 585f, 129f));
        Function.Call(Hash.SET_BLIP_SPRITE, Teatro2, 102);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Teatro");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Teatro2);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Teatro2, true);
        // New Addition
        _modBlips.Add(Teatro2);

        Blip Teatro = World.CreateBlip(new Vector3(232f, 1170f, 224f));
        Function.Call(Hash.SET_BLIP_SPRITE, Teatro, 102);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Teatro");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Teatro);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Teatro, true);
        // New Addition
        _modBlips.Add(Teatro);

        Blip Osservatorio = World.CreateBlip(new Vector3(-412f, 1170f, 325f));
        Function.Call(Hash.SET_BLIP_SPRITE, Osservatorio, 468);
        Function.Call(Hash.SET_BLIP_COLOUR, Osservatorio, 57);
        Function.Call(Hash.BEGIN_TEXT_COMMAND_SET_BLIP_NAME, "STRING");
        Function.Call(Hash._ADD_TEXT_COMPONENT_STRING, "Osservatorio");
        Function.Call(Hash.END_TEXT_COMMAND_SET_BLIP_NAME, Osservatorio);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Osservatorio, true);
        // New Addition
        _modBlips.Add(Osservatorio);

        Blip Pompieri2 = World.CreateBlip(new Vector3(-385f, 6135f, 26));
        Function.Call(Hash.SET_BLIP_SPRITE, Pompieri2, 436);
        Function.Call(Hash.SET_BLIP_COLOUR, Pompieri2, 17);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Pompieri2, true);
        // New Addition
        _modBlips.Add(Pompieri2);

        Blip Pompieri1 = World.CreateBlip(new Vector3(-655f, -116f, 26));
        Function.Call(Hash.SET_BLIP_SPRITE, Pompieri1, 436);
        Function.Call(Hash.SET_BLIP_COLOUR, Pompieri1, 17);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Pompieri1, true);
        // New Addition
        _modBlips.Add(Pompieri1);

        Blip Pompieri3 = World.CreateBlip(new Vector3(1200f, -1452f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Pompieri3, 436);
        Function.Call(Hash.SET_BLIP_COLOUR, Pompieri3, 17);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Pompieri3, true);
        // New Addition
        _modBlips.Add(Pompieri3);

        Blip Pompieri4 = World.CreateBlip(new Vector3(222f, -1636f, 18f));
        Function.Call(Hash.SET_BLIP_SPRITE, Pompieri4, 436);
        Function.Call(Hash.SET_BLIP_COLOUR, Pompieri4, 17);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Pompieri4, true);
        // New Addition
        _modBlips.Add(Pompieri4);

        Blip Hospital1 = World.CreateBlip(new Vector3(293f, -585f, 83f));
        Function.Call(Hash.SET_BLIP_SPRITE, Hospital1, 61);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Hospital1, true);
        // New Addition
        _modBlips.Add(Hospital1);

        Blip Hospital2 = World.CreateBlip(new Vector3(282f, -1419f, 26));
        Function.Call(Hash.SET_BLIP_SPRITE, Hospital2, 61);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Hospital2, true);
        // New Addition
        _modBlips.Add(Hospital2);

        Blip Hospital3 = World.CreateBlip(new Vector3(1842f, 3668f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Hospital3, 61);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Hospital3, true);
        // New Addition
        _modBlips.Add(Hospital3);

        Blip Hospital4 = World.CreateBlip(new Vector3(-228f, 6316f, 18f));
        Function.Call(Hash.SET_BLIP_SPRITE, Hospital4, 61);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Hospital4, true);
        // New Addition
        _modBlips.Add(Hospital4);

        Blip Hospital5 = World.CreateBlip(new Vector3(-468f, -359f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Hospital5, 61);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Hospital5, true);
        // New Addition
        _modBlips.Add(Hospital5);

        Blip Police1 = World.CreateBlip(new Vector3(655f, -15f, 83f));
        Function.Call(Hash.SET_BLIP_SPRITE, Police1, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police1, true);
        // New Addition
        _modBlips.Add(Police1);

        Blip Police2 = World.CreateBlip(new Vector3(811f, -1288f, 26));
        Function.Call(Hash.SET_BLIP_SPRITE, Police2, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police2, true);
        // New Addition
        _modBlips.Add(Police2);

        Blip Police3 = World.CreateBlip(new Vector3(404f, -1605f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Police3, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police3, true);
        // New Addition
        _modBlips.Add(Police3);

        // Blip Police4 = World.CreateBlip(new Vector3(-1096f, 8802f, 18f));
        //  Function.Call(Hash.SET_BLIP_SPRITE, Police4, 60);

        Blip Police5 = World.CreateBlip(new Vector3(-556f, -145f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Police5, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police5, true);
        // New Addition
        _modBlips.Add(Police5);

        Blip Police6 = World.CreateBlip(new Vector3(-431f, 6041f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Police6, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police6, true);
        // New Addition
        _modBlips.Add(Police6);

        Blip Police7 = World.CreateBlip(new Vector3(1859f, 3680f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Police7, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police7, true);
        // New Addition
        _modBlips.Add(Police7);

        Blip Police8 = World.CreateBlip(new Vector3(424f, -980f, 30f));
        Function.Call(Hash.SET_BLIP_SPRITE, Police8, 60);
        Function.Call(Hash.SET_BLIP_AS_SHORT_RANGE, Police8, true);
        // New Addition
        _modBlips.Add(Police8);
    }
}